import sys
import ctypes
from ctypes.wintypes import WIN32_FIND_DATAW as WIN32_FIND_DATA


_INVALID_HANDLE_VALUE = -1
_FindFirstFile = ctypes.windll.kernel32.FindFirstFileW
_FindNextFile = ctypes.windll.kernel32.FindNextFileW
_FindClose = ctypes.windll.kernel32.FindClose
_GetLastError = ctypes.windll.kernel32.GetLastError
FILE_ATTRIBUTE_REPARSE_POINT = 0x0400

def main():
    if len(sys.argv) != 2:
        print u"Usage: %s [target_file]" % sys.argv[0]
        return

    target = unicode(sys.argv[1], sys.getfilesystemencoding())

    print u"Target file is %s" % target

    wfd = WIN32_FIND_DATA()

    handle = _FindFirstFile(target, ctypes.byref(wfd))

    if handle != _INVALID_HANDLE_VALUE:
        print u"Found file: %s" % wfd.cFileName
        print u"Reparse point: %s" % (wfd.dwFileAttributes & FILE_ATTRIBUTE_REPARSE_POINT)
        print u"Attributes: %s" % wfd.dwFileAttributes
        while _FindNextFile(handle, ctypes.byref(wfd)):
            print u"Found file: %s" % wfd.cFileName
    else:
        print u"FindFirstFile failed (%d)" % _GetLastError()

    _FindClose(handle)


if __name__ == '__main__':
    main()